/*
This software and its source code is in the Public Domain.
Use at your own risk.

FixWiFi fixes a problem with some recent PalmOS PDAs that
do not allow you to start typing in some text fields 
immediately, but require an extra tap.  To install, 
just hotsync FixWiFi. You can run it to turn on and 
off.  Turn off before deleting.
*/

#ifndef PNOLET
#define PNOLET
#endif
#include <Standalone.h>
#include <PalmOS.h>
#include <PceNativeCall.h>
#include "FixWiFi_Res.h"
#include "stubs.h"

#define MAX_HANDLER_SIZE 65535

STANDALONE_CODE_RESOURCE_ID( armNotify );


Err SysNotifyUnregisterV50( LocalID id, UInt32 type, Int8 priority );
Err SysNotifyRegisterV50( LocalID id, UInt32 type, SysNotifyProcPtr function,
    Int8 priority, void* userDataP );
void HALInvalidateICache( void* address, UInt32 size );
static Boolean FindMe( LocalID* id );
Err DmGetNextDatabaseByTypeCreatorV50( Boolean init, DmSearchStatePtr stateP,
     UInt32 type, UInt32 creatorID, Boolean latest, LocalID *idP );



UInt32 SysNotifyRegister_hede
    (
    const void*      emulStateP,
    void*            userData68KP,
    Call68KFuncType* call68KFuncP
    )
{
    LocalID id;

    if ( ! FindMe( &id ) )
        return -1;

    if ( NULL == userData68KP ) {
        return SysNotifyUnregisterV50( id, sysNotifyEventDequeuedEvent, 0 );
    }
    else {
        HALInvalidateICache( userData68KP, MAX_HANDLER_SIZE );
        return SysNotifyRegisterV50( id, sysNotifyEventDequeuedEvent, userData68KP, 0, NULL );
    }

    return 0;
}



static Boolean FindMe( LocalID* idP )
{
    DmSearchStateType state;

    return errNone == DmGetNextDatabaseByTypeCreatorV50( true, &state,
               appType, appCreator,
               true, idP );
}


/* The second number in each of these stubs comes from the Incs/EntryNums lists 
   included in the Mobile-Stream unofficial SDK:
   http://www.mobile-stream.com/devzone.html.
   The first number comes from Libs/Makefile. */
STUB( SysNotifyUnregisterV50, 8, 2212 )
STUB( SysNotifyRegisterV50, 8, 2204 )
STUB( DmGetNextDatabaseByTypeCreatorV50, 8, 408 )
STUB_HALInvalidateICache

