/*
This software and its source code is in the Public Domain.
Use at your own risk.
*/

#ifdef ARM
#include <Standalone.h>
#endif
#include <PalmOS.h>

#include "FixWiFi.h"
#include "resident.h"

#ifdef ARM
  STANDALONE_CODE_RESOURCE_ID( armResident );
# include "stubs.h"
# define ARG68K( x )
# define ARG68K1( x )
# define ARM16( x )  ( UInt16 )( x )
# undef RESIDENT
# define RESIDENT
#else
# define ARG68K( x ) x,
# define ARG68K1( x ) x
# define ARM16( x )  ( ( ( UInt16 )( x ) << 8 ) | ( ( UInt16 )( x ) >> 8 ) )
#endif

RESIDENT Err DeqHandler( SysNotifyParamType* np );
RESIDENT void UnregisterMe( void );

Err DeqHandler( SysNotifyParamType* np )
{
    UInt32        tempValue;

    if ( Get( FTR_TIMER_STOP ) <= TimGetSeconds() ) {
        UnregisterMe();
    }
    else if ( ( ( EventType* )( np->notifyDetailsP ) )->eType == ARM16( firstUserEvent ) ) {

        ( ( EventType* )( np->notifyDetailsP ) )->eType = ARM16( nilEvent );
        UnregisterMe();
    }

    return errNone;
}



void UnregisterMe( void )
{
    SysNotifyParamType notify;

    MemSet( &notify, sizeof( SysNotifyParamType ), 0 );

    notify.notifyType  = appCreator;
    notify.broadcaster = appCreator;
    notify.notifyDetailsP = NULL;

    SysNotifyBroadcastDeferred( &notify, 0 );
}


#ifdef ARM
/* The second number in each of these stubs comes from the Incs/EntryNums lists
   included in the Mobile-Stream unofficial SDK:
   http://www.mobile-stream.com/devzone.html.
   The first number comes from Libs/Makefile. */
STUB_FtrGet
STUB_SysNotifyBroadcastDeferred
STUB_MemSet
STUB_TimGetSeconds
STUB_WinDrawChar
#endif

